<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iPcWire Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iPcWire Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iPcWire" --><!-- doxytag: inherits="iBase" -->
<p>This is a wire property class.  
 <a href="structiPcWire.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="wire_8h_source.html">propclass/wire.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iPcWire:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiPcWire.png" usemap="#iPcWire_map" alt=""/>
  <map id="iPcWire_map" name="iPcWire_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,56,24"/>
</map>
 </div></div>

<p><a href="structiPcWire-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcWire.html#ae1b1f88fdba43441b9575b9c0271b05f">AddInput</a> (const char *msg_mask, <a class="el" href="structiMessageChannel.html">iMessageChannel</a> *channel=0)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add a message to react too.  <a href="#ae1b1f88fdba43441b9575b9c0271b05f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcWire.html#adfd1503bc7c31173eb270f7be80d0272">AddOutput</a> (const char *msgid, <a class="el" href="structiMessageChannel.html">iMessageChannel</a> *channel=0, <a class="el" href="structiCelParameterBlock.html">iCelParameterBlock</a> *extra_params=0)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add an output message.  <a href="#adfd1503bc7c31173eb270f7be80d0272"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcWire.html#a152b3436eeba9bf592d6782f7ad8e0d0">MapParameter</a> (size_t id, const char *source, const char *dest, <a class="el" href="structiCelExpression.html">iCelExpression</a> *expression=0)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Map a parameter from one name to another directly.  <a href="#a152b3436eeba9bf592d6782f7ad8e0d0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcWire.html#a3d3e48f235e553243d511042988d8f5f">MapParameterExpression</a> (size_t id, const char *dest, const char *expression)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Map a parameter from one name to another directly.  <a href="#a3d3e48f235e553243d511042988d8f5f"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This is a wire property class. </p>
<p>A wire can connect two property classes. Basically a wire listens to a certain message on a channel and transforms it into another message (to possibly another channel).</p>
<p>This property class supports the following actions (add prefix 'cel.wire.action.' if you want to access this action through a message):</p>
<ul>
<li>AddInput: parameters 'mask' (string), optional 'entity' (string), ...</li>
<li>AddOutput: parameters 'msgid' (string), optional 'entity' (string), ...</li>
<li>MapParameter: parameters 'id' (long), optional 'source' (string), 'dest' (string), optional 'expression' (string). </li>
</ul>

<p>Definition at line <a class="el" href="wire_8h_source.html#l00040">40</a> of file <a class="el" href="wire_8h_source.html">wire.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="ae1b1f88fdba43441b9575b9c0271b05f"></a><!-- doxytag: member="iPcWire::AddInput" ref="ae1b1f88fdba43441b9575b9c0271b05f" args="(const char *msg_mask, iMessageChannel *channel=0)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcWire.html#ae1b1f88fdba43441b9575b9c0271b05f">iPcWire::AddInput</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>msg_mask</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structiMessageChannel.html">iMessageChannel</a> *&#160;</td>
          <td class="paramname"><em>channel</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a message to react too. </p>
<p>If the channel is not given then the message channel from the current entity will be used (the entity containing this property class). It is legal to call <a class="el" href="structiPcWire.html#ae1b1f88fdba43441b9575b9c0271b05f" title="Add a message to react too.">AddInput()</a> multiple times. In that case the wire will react to multiple messages from possible multiple sources. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">msg_mask</td><td>is a mask which will be used to subscribe to the given message channel. It can be a fully qualified message name or something shorter in which case more messages will be catched by this. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="adfd1503bc7c31173eb270f7be80d0272"></a><!-- doxytag: member="iPcWire::AddOutput" ref="adfd1503bc7c31173eb270f7be80d0272" args="(const char *msgid, iMessageChannel *channel=0, iCelParameterBlock *extra_params=0)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual size_t <a class="el" href="structiPcWire.html#adfd1503bc7c31173eb270f7be80d0272">iPcWire::AddOutput</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>msgid</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structiMessageChannel.html">iMessageChannel</a> *&#160;</td>
          <td class="paramname"><em>channel</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structiCelParameterBlock.html">iCelParameterBlock</a> *&#160;</td>
          <td class="paramname"><em>extra_params</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add an output message. </p>
<p>If the channel is not given then the message channel from the current entity will be used (the entity containing this property class). The resulting parameter block for the output message will be a combination of the parameter block from the input message overwritten by the parameters given here (if given). This function returns a unique identifier that you can use to give to the functions that affect the parameter modifications. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">msgid</td><td>is a fully qualified message id which will be used to send out. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a152b3436eeba9bf592d6782f7ad8e0d0"></a><!-- doxytag: member="iPcWire::MapParameter" ref="a152b3436eeba9bf592d6782f7ad8e0d0" args="(size_t id, const char *source, const char *dest, iCelExpression *expression=0)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcWire.html#a152b3436eeba9bf592d6782f7ad8e0d0">iPcWire::MapParameter</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>id</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>source</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>dest</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structiCelExpression.html">iCelExpression</a> *&#160;</td>
          <td class="paramname"><em>expression</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Map a parameter from one name to another directly. </p>
<p>With an optional expression the value can be modified. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">id</td><td>is the id as return by <a class="el" href="structiPcWire.html#adfd1503bc7c31173eb270f7be80d0272" title="Add an output message.">AddOutput()</a> or AddOutputAction(). This function will affect the parameter as given to that specific output. </td></tr>
    <tr><td class="paramname">source</td><td>is the optional name of the parameter in the source. This parameter is not used if you give an expression. </td></tr>
    <tr><td class="paramname">dest</td><td>is the name of the parameter as it should become in the destination. </td></tr>
    <tr><td class="paramname">expression</td><td>is an optional expression that can be used to modify the value in the destination. The expression will have access to the combined parameter block (parameters from original message as well as the extra parameters from the given output). </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a3d3e48f235e553243d511042988d8f5f"></a><!-- doxytag: member="iPcWire::MapParameterExpression" ref="a3d3e48f235e553243d511042988d8f5f" args="(size_t id, const char *dest, const char *expression)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcWire.html#a3d3e48f235e553243d511042988d8f5f">iPcWire::MapParameterExpression</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>id</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>dest</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>expression</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Map a parameter from one name to another directly. </p>
<p>This is a conveniance version that takes a string as an expression. In this version the expression is not optional. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">id</td><td>is the id as return by <a class="el" href="structiPcWire.html#adfd1503bc7c31173eb270f7be80d0272" title="Add an output message.">AddOutput()</a> or AddOutputAction(). This function will affect the parameter as given to that specific output. </td></tr>
    <tr><td class="paramname">dest</td><td>is the name of the parameter as it should become in the destination. </td></tr>
    <tr><td class="paramname">expression</td><td>is the expression string. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>propclass/<a class="el" href="wire_8h_source.html">wire.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
